Index: trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F
===================================================================
--- trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/dynphy_lonlat/phypluto/lect_start_archive.F	(revision 3275)
@@ -776,10 +776,10 @@
       DO iq=1,nqtot
           txt=trim(tname(iq))//"_surf"
-          if (txt.eq."h2o_vap") then
-            ! There is no surface tracer for h2o_vap;
+          if (txt.eq."h2o_gas") then
+            ! There is no surface tracer for h2o_gas;
             ! "h2o_ice" should be loaded instead
             txt="h2o_ice_surf"
             write(*,*) 'lect_start_archive: loading surface tracer',
-     &                     ' h2o_ice instead of h2o_vap'
+     &                     ' h2o_ice instead of h2o_gas'
           endif
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/aeropacity.F90	(revision 3275)
@@ -94,5 +94,5 @@
 
       real CLFtot
-      integer igen_ice,igen_vap ! to store the index of generic tracer
+      integer igen_ice,igen_gas ! to store the index of generic tracer
       logical dummy_bool ! dummy boolean just in case we need one
       ! integer i_rgcs_ice(aerogeneric)
Index: trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3275)
@@ -7,5 +7,5 @@
       subroutine callcorrk(ngrid,nlayer,pq,nq,qsurf,           &
           albedo,albedo_equivalent,emis,mu0,pplev,pplay,pt,    &
-          tsurf,fract,dist_star,aerosol,muvar,                 &
+          zzlay,tsurf,fract,dist_star,aerosol,muvar,                 &
           dtlw,dtsw,fluxsurf_lw,                               &
           fluxsurf_sw,fluxsurfabs_sw,fluxtop_lw,               &
@@ -30,10 +30,12 @@
       use aeropacity_mod, only: aeropacity
       use aeroptproperties_mod, only: aeroptproperties
-      use tracer_h, only: constants_epsi_generic
-      use comcstfi_mod, only: pi, mugaz, cpp
+      use tracer_h, only: constants_epsi_generic,igcm_ch4_gas,igcm_n2,mmol
+      use comcstfi_mod, only: pi, mugaz, cpp, r, g
       use callkeys_mod, only: varactive,diurnal,tracer,varfixed,satval, &
                               diagdtau,kastprof,strictboundcorrk,specOLR, &
                               tplanckmin,tplanckmax,global1d, &
-                              generic_condensation, aerohaze, haze_radproffix
+                              generic_condensation,aerohaze,haze_radproffix,&
+                              methane,carbox,cooling,nlte,strobel,&
+                              ch4fix,vmrch4_proffix,vmrch4fix
       use optcv_mod, only: optcv
       use optci_mod, only: optci
@@ -44,4 +46,5 @@
       use generic_tracer_index_mod, only: generic_tracer_index
       use planetwide_mod, only: planetwide_maxval, planetwide_minval
+      use radcommon_h, only: wavev,wavei
       implicit none
 
@@ -80,4 +83,5 @@
       REAL,INTENT(IN) :: pplay(ngrid,nlayer)       ! Mid-layer pressure (Pa).
       REAL,INTENT(IN) :: pt(ngrid,nlayer)          ! Air temperature (K).
+      REAL,INTENT(IN) :: zzlay(ngrid,nlayer)       ! Mid-layer altitude
       REAL,INTENT(IN) :: tsurf(ngrid)              ! Surface temperature (K).
       REAL,INTENT(IN) :: fract(ngrid)              ! Fraction of day.
@@ -157,8 +161,11 @@
 !$OMP THREADPRIVATE(tauaero)
       REAL*8 nfluxtopv,nfluxtopi,nfluxtop,fluxtopvdn
+      real*8 nfluxtopv_nu(L_NSPECTV)
       REAL*8 nfluxoutv_nu(L_NSPECTV)                 ! Outgoing band-resolved VI flux at TOA (W/m2).
       REAL*8 nfluxtopi_nu(L_NSPECTI)                 ! Net band-resolved IR flux at TOA (W/m2).
       REAL*8 fluxupi_nu(L_NLAYRAD,L_NSPECTI)         ! For 1D diagnostic.
       REAL*8 fmneti(L_NLAYRAD),fmnetv(L_NLAYRAD)
+      real*8 fmneti_nu(L_NLAYRAD,L_NSPECTI) !
+      real*8 fmnetv_nu(L_NLAYRAD,L_NSPECTV) !
       REAL*8 fluxupv(L_NLAYRAD),fluxupi(L_NLAYRAD)
       REAL*8 fluxdnv(L_NLAYRAD),fluxdni(L_NLAYRAD)
@@ -211,9 +218,23 @@
       REAL*8 surface_stellar_flux   ! Stellar flux reaching the surface. Useful for equivalent albedo calculation.
 
+      !     NLTE factor for CH4
+      real eps_nlte_sw23(ngrid,nlayer) ! CH4 NLTE efficiency factor for zdtsw
+      real eps_nlte_sw33(ngrid,nlayer) ! CH4 NLTE efficiency factor for zdtsw
+      real eps_nlte_lw(ngrid,nlayer) ! CH4 NLTE efficiency factor for zdtsw
+      integer Nfine,ifine
+      parameter(Nfine=701)
+      real,save :: levdat(Nfine),vmrdat(Nfine)
+      real :: vmrch4(ngrid,nlayer)              ! vmr ch4 from vmrch4_proffix
+
+      REAL dtlw_nu(nlayer,L_NSPECTI) ! heating rate (K/s) due to LW in spectral bands
+      REAL dtsw_nu(nlayer,L_NSPECTV) ! heating rate (K/s) due to SW in spectral bands
+
       ! local variable
+      REAL dpp  ! intermediate
+
       integer ok ! status (returned by NetCDF functions)
 
-      integer igcm_generic_vap, igcm_generic_ice! index of the vap and ice of generic_tracer
-      logical call_ice_vap_generic ! to call only one time the ice/vap pair of a tracer
+      integer igcm_generic_gas, igcm_generic_ice! index of the vap and ice of generic_tracer
+      logical call_ice_gas_generic ! to call only one time the ice/vap pair of a tracer
       real, save :: metallicity ! metallicity of planet --- is not used here, but necessary to call function Psat_generic
 !$OMP THREADPRIVATE(metallicity)
@@ -327,7 +348,5 @@
          ENDIF
 
-#ifndef MESOSCALE
          if (is_master) call system('rm -f surf_vals_long.out')
-#endif
 
          call su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
@@ -434,5 +453,5 @@
 
 
-         if(varfixed .and. generic_condensation)then
+         if(varfixed .and. (generic_condensation .or. methane .or. carbox))then
             write(*,*) "Deep generic tracer vapor mixing ratio ? (no effect if negative) "
             qvap_deep=-1. ! default value
@@ -504,4 +523,40 @@
       endif
 
+
+!-----------------------------------------------------------------------
+!     Prepare CH4 mixing ratio for radiative transfer
+      IF (methane) then
+        vmrch4(:,:)=0.
+
+        if (ch4fix) then
+           if (vmrch4_proffix) then
+            !! Interpolate on the model vertical grid
+             do ig=1,ngrid
+               CALL interp_line(levdat,vmrdat,Nfine, &
+                      zzlay(ig,:)/1000.,vmrch4(ig,:),nlayer)
+             enddo
+           else
+            vmrch4(:,:)=vmrch4fix
+           endif
+        else
+            vmrch4(:,:)=pq(:,:,igcm_ch4_gas)*100.* &
+                        mmol(igcm_n2)/mmol(igcm_ch4_gas)
+        endif
+      ENDIF
+
+!     Prepare NON LTE correction in Pluto atmosphere
+      IF (nlte) then
+        CALL nlte_ch4(ngrid,nlayer,nq,pplay,pplev,pt,vmrch4,&
+                  eps_nlte_sw23,eps_nlte_sw33,eps_nlte_lw)
+      ENDIF
+!     Net atmospheric radiative cooling rate from C2H2 (K.s-1):
+!     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    !   dtlw_hcn_c2h2=0.
+      if (cooling) then
+        !  CALL cooling_hcn_c2h2(ngrid,nlayer,pplay,&
+                                !   pt,dtlw_hcn_c2h2)
+      endif
+
+
 !-----------------------------------------------------------------------
       do ig=1,ngrid ! Starting Big Loop over every GCM column
@@ -671,5 +726,5 @@
       !-----------------------------------------------------------------------
 
-      if (generic_condensation) then
+      if (generic_condensation .or. methane .or. carbox) then
 
          ! For now, only one GCS tracer can be both variable and radiatively active
@@ -679,11 +734,11 @@
          do iq=1,nq
 
-            call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-
-            if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+            call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+
+            if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
 
                if(varactive)then
 
-                  i_var=igcm_generic_vap
+                  i_var=igcm_generic_gas
                   do l=1,nlayer
                      qvar(2*l)   = pq(ig,nlayer+1-l,i_var)
@@ -731,5 +786,5 @@
       !-----------------------------------------------------------------------
 
-      if (.not. generic_condensation) then
+      if (.not. (generic_condensation .or. methane .or. carbox)) then
          do k=1,L_LEVELS
             qvar(k) = 1.0D-7
@@ -741,12 +796,14 @@
          ! IMPORTANT: Now convert from kg/kg to mol/mol.
          do k=1,L_LEVELS
-            if (generic_condensation) then
+            if (generic_condensation .or. methane .or. carbox) then
                do iq=1,nq
-                  call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-                  if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
-
-                     epsi_generic=constants_epsi_generic(iq)
-
-                     qvar(k) = qvar(k)/(epsi_generic+qvar(k)*(1.-epsi_generic))
+                  call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+                  if (call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
+                    if(.not. varactive .or. i_var.eq.iq)then
+
+                        epsi_generic=constants_epsi_generic(iq)
+
+                        qvar(k) = qvar(k)/(epsi_generic+qvar(k)*(1.-epsi_generic))
+                    endif
 
                   endif
@@ -762,5 +819,5 @@
       DO l=1,nlayer
          muvarrad(2*l)   = muvar(ig,nlayer+2-l)
-         muvarrad(2*l+1) = (muvar(ig,nlayer+2-l)+muvar(ig,max(nlayer+1-l,1)))/2
+             muvarrad(2*l+1) = (muvar(ig,nlayer+2-l)+muvar(ig,max(nlayer+1-l,1)))/2
       END DO
 
@@ -965,8 +1022,8 @@
                  tmid,pmid,taugsurf,qvar,muvarrad)
 
-            call sfluxv(dtauv,tauv,taucumv,albv,dwnv,wbarv,cosbv,  &
-                 acosz,stel_fract,                                 &
-                 nfluxtopv,fluxtopvdn,nfluxoutv_nu,nfluxgndv_nu,   &
-                 fmnetv,fluxupv,fluxdnv,fzerov,taugsurf)
+            call sfluxv(dtauv,tauv,taucumv,albv,dwnv,wbarv,cosbv,   &
+                 acosz,stel_fract,nfluxtopv,fluxtopvdn,nfluxoutv_nu,&
+                 nfluxgndv_nu,nfluxtopv_nu, &
+                 fmnetv,fmnetv_nu,fluxupv,fluxdnv,fzerov,taugsurf)
 
          else ! During the night, fluxes = 0.
@@ -1010,5 +1067,5 @@
          call sfluxi(plevrad,tlevrad,dtaui,taucumi,ubari,albi,      &
               wnoi,dwni,cosbi,wbari,nfluxtopi,nfluxtopi_nu,         &
-              fmneti,fluxupi,fluxdni,fluxupi_nu,fzeroi,taugsurfi)
+              fmneti,fmneti_nu,fluxupi,fluxdni,fluxupi_nu,fzeroi,taugsurfi)
 
 !-----------------------------------------------------------------------
@@ -1050,17 +1107,35 @@
 
 !     Finally, the heating rates
-
          DO l=2,L_NLAYRAD
-            dtsw(ig,L_NLAYRAD+1-l)=(fmnetv(l)-fmnetv(l-1))  &
-                *glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
-            dtlw(ig,L_NLAYRAD+1-l)=(fmneti(l)-fmneti(l-1))  &
-                *glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
+            ! dtsw(ig,L_NLAYRAD+1-l)=(fmnetv(l)-fmnetv(l-1))  &
+            !     *glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
+            dpp = glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
+            do nw=1,L_NSPECTV
+                dtsw_nu(L_NLAYRAD+1-l,nw)= &
+                   (fmnetv_nu(l,nw)-fmnetv_nu(l-1,nw))*dpp
+            end do
+
+            ! dtlw(ig,L_NLAYRAD+1-l)=(fmneti(l)-fmneti(l-1))  &
+            !     *glat(ig)/(cpp*scalep*(plevrad(2*l+1)-plevrad(2*l-1)))
+            do nw=1,L_NSPECTI
+                dtlw_nu(L_NLAYRAD+1-l,nw)= &
+                   (fmneti_nu(l,nw)-fmneti_nu(l-1,nw))*dpp
+            end do
          END DO
 
 !     These are values at top of atmosphere
-         dtsw(ig,L_NLAYRAD)=(fmnetv(1)-nfluxtopv)           &
-             *glat(ig)/(cpp*scalep*(plevrad(3)-plevrad(2)))
-         dtlw(ig,L_NLAYRAD)=(fmneti(1)-nfluxtopi)           &
-             *glat(ig)/(cpp*scalep*(plevrad(3)-plevrad(2)))
+        !  dtsw(ig,L_NLAYRAD)=(fmnetv(1)-nfluxtopv)           &
+        !      *glat(ig)/(cpp*scalep*(plevrad(3)-plevrad(2)))
+        !  dtlw(ig,L_NLAYRAD)=(fmneti(1)-nfluxtopi)           &
+        !      *glat(ig)/(cpp*scalep*(plevrad(3)-plevrad(2)))
+         dpp = g/(cpp*scalep*(plevrad(3)-plevrad(1)))
+         do nw=1,L_NSPECTV
+            dtsw_nu(L_NLAYRAD,nw)= &
+             (fmnetv_nu(1,nw)-nfluxtopv_nu(nw))*dpp
+         end do
+         do nw=1,L_NSPECTI
+             dtlw_nu(L_NLAYRAD,nw)= &
+             (fmneti_nu(1,nw)-nfluxtopi_nu(nw))*dpp
+         end do
 
       !  Optical thickness diagnostics (added by JVO)
@@ -1084,9 +1159,67 @@
       endif
 
+! **********************************************************
+!     NON NLTE correction in Pluto atmosphere
+!     And conversion of LW spectral heating rates to total rates
+! **********************************************************
+
+      if (.not.nlte) then
+        eps_nlte_sw23(ig,:) =1. ! IF no NLTE
+        eps_nlte_sw33(ig,:) =1. ! IF no NLTE
+        eps_nlte_lw(ig,:) =1. ! IF no NLTE
+     endif
+
+     do l=1,nlayer
+
+        !LW
+        dtlw(ig,l) =0.
+!           dtlw_co(ig,l) =0.  ! only for diagnostic
+        do nw=1,L_NSPECTI
+          ! wewei : wavelength in micrometer
+          if ((wavei(nw).gt.6.).and.(wavei(nw).lt.9)) then
+            dtlw_nu(l,nw)=dtlw_nu(l,nw)*eps_nlte_lw(ig,l)
+          else
+            !dtlw_nu(l,nw)=1.*dtlw_nu(l,nw) ! no CO correction (Strobbel 1996)
+            dtlw_nu(l,nw)=0.33*dtlw_nu(l,nw) ! CO correction (Strobbel 1996)
+!               dtlw_co(ig,l)=dtlw_co(ig,l)+ dtlw_nu(l,nw) ! diagnostic
+          end if
+          dtlw(ig,l)=dtlw(ig,l)+ dtlw_nu(l,nw) !average now on each wavelength
+        end do
+        ! adding c2h2 if cooling active
+        ! dtlw(ig,l)=dtlw(ig,l)+dtlw_hcn_c2h2(ig,l)
+
+        !SW
+        dtsw(ig,l) =0.
+
+        if (strobel) then
+
+         do nw=1,L_NSPECTV
+          if ((wavev(nw).gt.2).and.(wavev(nw).lt.2.6)) then
+            dtsw_nu(l,nw)=dtsw_nu(l,nw)*eps_nlte_sw23(ig,l)
+          elseif ((wavev(nw).gt.3).and.(wavev(nw).lt.3.6)) then
+            dtsw_nu(l,nw)=dtsw_nu(l,nw)*eps_nlte_sw33(ig,l)
+          else
+            dtsw_nu(l,nw)=dtsw_nu(l,nw)
+          end if
+          dtsw(ig,l)=dtsw(ig,l)+ dtsw_nu(l,nw)
+         end do
+
+        else ! total heating rates multiplied by nlte coef
+
+         do nw=1,L_NSPECTV
+            dtsw_nu(l,nw)=dtsw_nu(l,nw)*eps_nlte_sw23(ig,l)
+            dtsw(ig,l)=dtsw(ig,l)+ dtsw_nu(l,nw)
+         enddo
+
+        endif
+
+
+     end do
+! **********************************************************
+
 
 !-----------------------------------------------------------------------
       end do ! End of big loop over every GCM column.
 !-----------------------------------------------------------------------
-
 
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/condensation_generic_mod.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/condensation_generic_mod.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/condensation_generic_mod.F90	(revision 3275)
@@ -18,5 +18,5 @@
 !     -------
 !     Calculates large-scale condensation of generic tracer "tname".
-!     By convention, tname ends with the suffix "_vap", as it represents the 
+!     By convention, tname ends with the suffix "_gas", as it represents the 
 !     gas phase of the generic tracer
 !     
@@ -39,5 +39,5 @@
         REAL, intent(in) :: pdt(ngrid,nlayer)     ! physical temperature tendency (K/s)
         REAL, intent(in) :: pdq(ngrid,nlayer,nq)  ! physical tracer tendency (K/s)
-        ! CHARACTER(*), intent(in) :: tname_vap     ! name of the tracer we consider. BY convention, it ends with _vap !!!
+        ! CHARACTER(*), intent(in) :: tname_gas     ! name of the tracer we consider. BY convention, it ends with _gas !!!
         REAL, intent(out) :: pdtlsc(ngrid,nlayer)  ! incrementation de la temperature (K)
         REAL, intent(out) :: pdqvaplsc(ngrid,nlayer,nq) ! incrementation de la vapeur du traceur
@@ -49,11 +49,11 @@
         REAL, SAVE :: qvap_deep   ! deep mixing ratio of vapor when simulating bottom less planets
         REAL, SAVE :: qvap_top   ! top mixing ratio of vapor when simulating bottom less planets
-        logical, save :: perfect_vap_profile
-!$OMP THREADPRIVATE(metallicity, qvap_deep, qvap_top, perfect_vap_profile)
+        logical, save :: perfect_gas_profile
+!$OMP THREADPRIVATE(metallicity, qvap_deep, qvap_top, perfect_gas_profile)
 
 !       Local variables
 
         ! to call only one time the ice/vap pair of a tracer
-        logical call_ice_vap_generic
+        logical call_ice_gas_generic
 
         INTEGER i, k , nn, iq
@@ -69,5 +69,5 @@
         real zt(ngrid),local_p,psat_tmp,dlnpsat_tmp,Lcp,zqs_temp,zdqs
         real zqs_temp_1, zqs_temp_2, zqs_temp_3
-        integer igcm_generic_vap, igcm_generic_ice! index of the vap and ice of generic_tracer
+        integer igcm_generic_gas, igcm_generic_ice! index of the vap and ice of generic_tracer
         ! CHARACTER(len=*) :: tname_ice
         ! evaporation calculations
@@ -96,8 +96,8 @@
                 write(*,*) " qvap_top = ",qvap_top 
                 
-                write(*,*) " perfect_vap_profile ? "
-                perfect_vap_profile=.false. ! default value
-                call getin_p("perfect_vap_profile",perfect_vap_profile)
-                write(*,*) " perfect_vap_profile = ",perfect_vap_profile
+                write(*,*) " perfect_gas_profile ? "
+                perfect_gas_profile=.false. ! default value
+                call getin_p("perfect_gas_profile",perfect_gas_profile)
+                write(*,*) " perfect_gas_profile = ",perfect_gas_profile
 
                 firstcall = .false.
@@ -115,9 +115,9 @@
         do iq=1,nq
 
-                call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-
-                if(call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
+                call generic_tracer_index(nq,iq,igcm_generic_gas,igcm_generic_ice,call_ice_gas_generic)
+
+                if(call_ice_gas_generic) then ! to call only one time the ice/vap pair of a tracer
                         m=constants_mass(iq)
-                        delta_vapH=constants_delta_vapH(iq)
+                        delta_gasH=constants_delta_gasH(iq)
                         Tref=constants_Tref(iq)
                         Pref=constants_Pref(iq)
@@ -139,5 +139,5 @@
                                         !	    zt(i)=15.   ! check too low temperatures
                                         endif
-                                        zx_q(i) = pq(i,k,igcm_generic_vap)+pdq(i,k,igcm_generic_vap)*ptimestep
+                                        zx_q(i) = pq(i,k,igcm_generic_gas)+pdq(i,k,igcm_generic_gas)*ptimestep
 
                                         call Psat_generic(zt(i),local_p,metallicity,psat_tmp,zqs_temp)
@@ -189,12 +189,12 @@
 
                                 !Tendances de t et q
-                                pdqvaplsc(1:ngrid,k,igcm_generic_vap)  = - zcond(1:ngrid) 
-                                pdqliqlsc(1:ngrid,k,igcm_generic_ice) = - pdqvaplsc(1:ngrid,k,igcm_generic_vap)
+                                pdqvaplsc(1:ngrid,k,igcm_generic_gas)  = - zcond(1:ngrid) 
+                                pdqliqlsc(1:ngrid,k,igcm_generic_ice) = - pdqvaplsc(1:ngrid,k,igcm_generic_gas)
                                 pdtlsc(1:ngrid,k)  = pdtlsc(1:ngrid,k) + pdqliqlsc(1:ngrid,k,igcm_generic_ice)*Lcp
 
                         Enddo ! k= nlayer, 1, -1
 
-                        if ((perfect_vap_profile) .and. (ngrid.eq.1)) then
-                                ! perfect_vap_profile is a mode that should a priori only be used in 1D:
+                        if ((perfect_gas_profile) .and. (ngrid.eq.1)) then
+                                ! perfect_gas_profile is a mode that should a priori only be used in 1D:
                                 ! as it is written below, it aims to force the vap profile:
                                 ! - below condensation, it is forced to qvap_deep
@@ -202,5 +202,5 @@
                                 ! - above the cold trap, it is forced to the value allowed by the cold trap
 
-                                ! perfect_vap_profile can be customed as you want
+                                ! perfect_gas_profile can be customed as you want
                                 
                                 tau = 10. * ptimestep ! tau must not be lower than the physical step time. 
@@ -223,5 +223,5 @@
                                 if (k_cold_trap .lt. nlayer) then
                                         do k=k_cold_trap+1,nlayer
-                                                pdqvaplsc(1,k,igcm_generic_vap) = (pq(1,k_cold_trap,igcm_generic_vap) - pq(1,k,igcm_generic_vap))/tau - pdq(1,k,igcm_generic_vap)
+                                                pdqvaplsc(1,k,igcm_generic_gas) = (pq(1,k_cold_trap,igcm_generic_gas) - pq(1,k,igcm_generic_gas))/tau - pdq(1,k,igcm_generic_gas)
                                         enddo
                                 endif
@@ -231,8 +231,8 @@
                                         call Psat_generic(zt(1),pplay(1,k),metallicity,psat_tmp,zqs_temp)
                                         if (zqs_temp .gt. qvap_deep) then
-                                                pdqvaplsc(1,k,igcm_generic_vap)  = (qvap_deep - pq(1,k,igcm_generic_vap))/tau - pdq(1,k,igcm_generic_vap)
+                                                pdqvaplsc(1,k,igcm_generic_gas)  = (qvap_deep - pq(1,k,igcm_generic_gas))/tau - pdq(1,k,igcm_generic_gas)
                                         endif
                                         if (zqs_temp .lt. qvap_deep) then
-                                                pdqvaplsc(1,k,igcm_generic_vap)  = (0.99*zqs_temp - pq(1,k,igcm_generic_vap))/tau - pdq(1,k,igcm_generic_vap)
+                                                pdqvaplsc(1,k,igcm_generic_gas)  = (0.99*zqs_temp - pq(1,k,igcm_generic_gas))/tau - pdq(1,k,igcm_generic_gas)
                                         endif
                                 enddo
@@ -246,5 +246,5 @@
                                 ! brings lower generic vapor ratio to a fixed value.
                                 ! tau is in seconds and must not be lower than the physical step time.
-                                pdqvaplsc(1:ngrid,1,igcm_generic_vap) = (qvap_deep - pq(1:ngrid,1,igcm_generic_vap))/tau - pdq(1:ngrid,1,igcm_generic_vap)
+                                pdqvaplsc(1:ngrid,1,igcm_generic_gas) = (qvap_deep - pq(1:ngrid,1,igcm_generic_gas))/tau - pdq(1:ngrid,1,igcm_generic_gas)
                         endif
                         if (qvap_top >= 0.) then
@@ -252,7 +252,7 @@
                                 ! brings lower generic vapor ratio to a fixed value.
                                 ! tau is in seconds and must not be lower than the physical step time.
-                                pdqvaplsc(1:ngrid,nlayer,igcm_generic_vap) = (qvap_top - pq(1:ngrid,nlayer,igcm_generic_vap))/tau - pdq(1:ngrid,nlayer,igcm_generic_vap)
+                                pdqvaplsc(1:ngrid,nlayer,igcm_generic_gas) = (qvap_top - pq(1:ngrid,nlayer,igcm_generic_gas))/tau - pdq(1:ngrid,nlayer,igcm_generic_gas)
                         endif
-                endif !if(call_ice_vap_generic)
+                endif !if(call_ice_gas_generic)
         enddo ! iq=1,nq
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/convadj.F
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/convadj.F	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/convadj.F	(revision 3275)
@@ -304,10 +304,10 @@
          end do
          ! do l = 1, nlay
-         !    print*,'zq(ig,:,vap)     = ',zq(i,l,igcm_h2o_vap)
+         !    print*,'zq(ig,:,vap)     = ',zq(i,l,igcm_h2o_gas)
          ! end do
          ! do l = 1, nlay
-         !    print*,'zq2(ig,:,vap)    = ',zq2(i,l,igcm_h2o_vap)
+         !    print*,'zq2(ig,:,vap)    = ',zq2(i,l,igcm_h2o_gas)
          ! end do
-         !    print*,'zqm(vap)         = ',zqm(igcm_h2o_vap)
+         !    print*,'zqm(vap)         = ',zqm(igcm_h2o_gas)
             print*,'jadrs=',jadrs
 
Index: trunk/LMDZ.PLUTO/libf/phypluto/generic_cloud_common_h.F90
===================================================================
--- trunk/LMDZ.PLUTO/libf/phypluto/generic_cloud_common_h.F90	(revision 3258)
+++ trunk/LMDZ.PLUTO/libf/phypluto/generic_cloud_common_h.F90	(revision 3275)
@@ -16,5 +16,5 @@
     implicit none 
     real, save :: m  ! molecular mass of the specie (g/mol)
-    real, save :: delta_vapH ! Enthalpy of vaporization (J/mol)
+    real, save :: delta_gasH ! Enthalpy of vaporization (J/mol)
     real,save :: Tref ! Ref temperature for Clausis-Clapeyron (K)
     real,save :: Pref ! Reference pressure for Clausius Clapeyron (Pa)
@@ -46,62 +46,62 @@
         if (trim(specname) .eq. "Mg") then
             print*,"Loading data for Mg"
-            delta_vapH = 521.7E3 !J/mol
+            delta_gasH = 521.7E3 !J/mol
             Tref = 2303.0 !K
             Pref =   1.0E5 !in Pa
             m = 140.6931
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
             metallicity_coeff=1.0*log(10.0)
             
         else if (trim(specname) .eq. "Na") then
             print*,"Loading data for Na"
-            delta_vapH = 265.9E3
+            delta_gasH = 265.9E3
             Tref = 1624.0
             Pref =  1.0E5
             m = 78.04454 !Na2S
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
             metallicity_coeff=0.5*log(10.0)
             
         else if (trim(specname) .eq. "Fe") then 
             print*,"Loading data for Fe"
-            delta_vapH = 401.9E3 
+            delta_gasH = 401.9E3 
             Tref = 2903.0
             Pref  = 1.0E5
             m = 55.8450
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
             metallicity_coeff=0.0*log(10.0)
             
         else if (trim(specname) .eq. "Cr") then
             print*,"Loading data for Cr"
-            delta_vapH = 394.2E3
+            delta_gasH = 394.2E3
             Tref = 2749.0
             Pref  = 1.0E5
             m = 51.9961
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
             metallicity_coeff=0.0*log(10.0)
             
         else if (trim(specname) .eq. "KCl") then 
             print*,"Loading data for KCl"
-            delta_vapH = 217.9E3
+            delta_gasH = 217.9E3
             Tref = 1495.0
             Pref = 1.0E5
             metallicity_coeff=0.0*log(10.0)
             m = 74.5498
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
         else if (trim(specname) .eq. "Mn") then 
             print*,"Loading data for Mn"
-            delta_vapH = 455.8E3
+            delta_gasH = 455.8E3
             Tref = 2064.0
             Pref = 1.0E5
             metallicity_coeff=1.0*log(10.0)
             m = 87.003049
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
         else if (trim(specname) .eq. "Zn") then 
             print*,"Loading data for Zn"
-            delta_vapH = 303.9E3
+            delta_gasH = 303.9E3
             Tref = 1238.0
             Pref = 1.0E5
             metallicity_coeff=1.0*log(10.0)
             m = 97.445
-            RLVTT_generic = delta_vapH/(m/1000.)
+            RLVTT_generic = delta_gasH/(m/1000.)
         else
             print*,"Unknow species (not in Mg, Fe, Na, KCl, Cr, Mn or Zn)"
@@ -138,7 +138,7 @@
             if (index(table_traceurs_line,specname) /= 0) then
                 
-                if (index(table_traceurs_line,'delta_vapH='   ) /= 0) then
-                    read(table_traceurs_line(index(table_traceurs_line,'delta_vapH=')+len('delta_vapH='):),*) delta_vapH
-                    print*, 'delta_vapH ', delta_vapH
+                if (index(table_traceurs_line,'delta_gasH='   ) /= 0) then
+                    read(table_traceurs_line(index(table_traceurs_line,'delta_gasH=')+len('delta_gasH='):),*) delta_gasH
+                    print*, 'delta_gasH ', delta_gasH
                 end if
                 if (index(table_traceurs_line,'Tref='   ) /= 0) then
@@ -178,5 +178,5 @@
         close(117)
 
-        RLVTT_generic=delta_vapH/(m/1000.)
+        RLVTT_generic=delta_gasH/(m/1000.)
 
         write(*,*) 'RLVTT_generic', RLVTT_generic
@@ -190,6 +190,6 @@
     !============================================================================
     !   Clausius-Clapeyron relation : 
-    !   d(Ln(psat))/dT = delta_vapH/(RT^2)
-    !   ->Psat = Pref * exp(-delta_vapH/R*(1/T-1/Tref))
+    !   d(Ln(psat))/dT = delta_gasH/(RT^2)
+    !   ->Psat = Pref * exp(-delta_gasH/R*(1/T-1/Tref))
     !
     !   Authors 
@@ -203,5 +203,5 @@
         real, intent(out) :: psat,qsat !saturation vapor pressure (Pa) and mass mixing ratio at saturation (kg/kg) of the layer 
 
-        psat = pref*exp(-delta_vapH/(r*mugaz/1000.)*(1/T-1/Tref)-metallicity_coeff*metallicity) ! in Pa (because pref in Pa)
+        psat = pref*exp(-delta_gasH/(r*mugaz/1000.)*(1/T-1/Tref)-metallicity_coeff*metallicity) ! in Pa (because pref in Pa)
 
         if (psat .gt. p) then 
@@ -217,5 +217,5 @@
     !===============================================================================
     !   Compute dqsat = L/cp* d(qsat)/dT and d(Ln(psat)) = L/cp*d(Ln(psat))/dT
-    !   we have d(ln(psat))/dT =  delta_vapH/R*(1/T^2) for clausius-clapeyron
+    !   we have d(ln(psat))/dT =  delta_gasH/R*(1/T^2) for clausius-clapeyron
     !   r*mugaz/1000. is the perfect gaz constant in the computation of "dummy"
     !   Authors 
@@ -235,5 +235,5 @@
         real :: dummy ! used to store d(ln(psat))/dT
 
-        dummy = delta_vapH/((r*mugaz/1000.)*(T**2)) 
+        dummy = delta_gasH/((r*mugaz/1000.)*(T**2)) 
 
         if (psat .gt. p) then 
@@ -270,5 +270,5 @@
 
 
-        Tsat = 1/(1/Tref - (r*mugaz/1000.)/delta_vapH*Log(p/Pref))
+        Tsat = 1/(1/Tref - (r*mugaz/1000.)/delta_gasH*Log(p/Pref))
 
     end subroutine Tsat_generic
